// Exercise 10.2.
// Adds the TListClass type.

#include <iostream.h>
#include <string.h>
#include <stdio.h>

typedef char string80[80];

const int MaxListSize = 50;

class TListBoxData {
public:
  TListBoxData() {};
  // Adding =0 to next prototype makes this an
  // abstract or "pure" function that must be
  // overridden in derived classes.
  virtual void GetText (string80 &Text) = 0;
  // Because this is a "pure" function, there
  // is not implementation for this class.
};// MaxListSize

class TListBox {
public:
  TListBox();
  void AddItem ( TListBoxData * AnObject );
  void DisplayListBox(void);
private:
  int TotalItems;
  int CursorLocation;
  TListBoxData * ListBoxData[MaxListSize];
}; // TListBox


// =============================================
// The following classes are derived from the abstract
// base class, TListBoxData.  You can add more data
// types if you wish: be sure to override the GetText()
// member function for each type that you add.
class TListInteger : public TListBoxData {
// This class stores an int value.
public:
  TListInteger(int X) : TListBoxData()
     { intValue = X;};
  virtual void GetText( string80 &Text);
private:
 int intValue;
};


class TListString : public TListBoxData {
// This class stores an string value.
public:
  TListString(string80 X) : TListBoxData()
     { strcpy( strValue, X );};
  virtual void GetText( string80 &Text);
private:
 string80 strValue;
};


class TListFloat : public TListBoxData {
// This class stores an float value.
public:
  TListFloat(float X) : TListBoxData()
     { fltValue = X;};
  virtual void GetText( string80 &Text);
private:
 float fltValue;
};

// TClass demonstrates the placement of a class type
// into the lixt box.  The Display() member function
// is not called in this example code.
class TClass {
public:
  int x;
  int y;
  void Display(void) { cout << x << ", " << y; };
};

class TListClass: public TListBoxData {
// This class stores a structure type.
public:
  // You might also wish to add a constructor that
  // enables you to use a structure type in place of p1 and p2.
  TListClass(int p1, int p2) : TListBoxData()
    { Value.x = p1; Value.y = p2; }
  virtual void GetText (string80 &Text);
private:
  TClass Value;

};

// =============================================
void main(void) {
  TListBox AListBox;

  // Fill up the list box with three different kinds
  // of data.
  AListBox.AddItem( new TListInteger( 57 ) );
  AListBox.AddItem( new TListInteger( 99 ) );
  AListBox.AddItem( new TListString( "Hello 'dare!" ) );
  AListBox.AddItem( new TListFloat( 3.14159 ) );
  AListBox.AddItem( new TListString( "I'm a string too" ) );
  AListBox.AddItem( new TListInteger( 1 ) );
  AListBox.AddItem( new TListFloat( 2.718 ) );
  AListBox.AddItem( new TListClass( 55, 66 ) );
  AListBox.AddItem( new TListClass( -2, 2 ) );

  // Display the content of the list box.
  AListBox.DisplayListBox();

  cout << "Press Enter to continue.";
  cin.get();
} // main


// =============================================
TListBox::TListBox()
{
  TotalItems = 0;
};


void TListBox::AddItem ( TListBoxData * AnObject )
{
/* Adds objects into the list. For simplicity in this
  example, the "list" is really just an array, and no
  error result is returned if you try to add too many
  items to the "list."
*/
  if  (TotalItems <= MaxListSize)
    ListBoxData [TotalItems++] = AnObject;
}; // AddItem


void TListBox::DisplayListBox(void) {
/* This could be modified to display an actual list
  box, and perhaps allow cursor movements to scroll
  through the list box. For now, it just writes the
  returned string for each object.
*/
  int i;
  string80 DemoStr;

  // Display each object in the list box; use the
  // object's own GetText() member function to
  // convert its internal format into generic text.
  for (i = 0; i< TotalItems; i++) {
    ListBoxData[i]->GetText( DemoStr );
    cout << DemoStr << endl;
  };
};


// =============================================
void TListInteger::GetText (string80 &Text)
{
  sprintf(Text, "%d", intValue );
}; // GetText


// =============================================
void TListString::GetText (string80 &Text)
{
  strcpy( Text, strValue );
}; // GetText


// =============================================
void TListFloat::GetText (string80 &Text)
{
  sprintf( Text, "%d", fltValue );
}; // GetText


// =============================================
void TListClass::GetText (string80 &Text)
{
  sprintf( Text, "(%d,%d)", Value.x, Value.y );
}; // GetText
