// Exercise 11.5.
// This is a modified version of Chapter 7's LISTDEMO.CPP program.
// Two new commands have been added:  Save and Open.

#include <iostream.h>
#include <fstream.h>
#include "list-mod.h"

//===============================================
void main(void) {
  // Used to process keyboard command input.
  char command_ch, direction_ch;
  char TheName[MAXNAMESIZE];
  list_type TheList;          // The list object.

  TheList.Initialize_List();
  do {
    cout << "Select A)dd, L)ist, S)ave, O)pen or Q)uit? ";
    cin.get(command_ch);
    cin.ignore(1);

    switch(command_ch) {
      // Add a new entry to the list.
      case 'a': case 'A': {
        cout << "Enter name:  ";
	cin.getline(TheName, sizeof(TheName) );
	TheList.Add_to_Tail(TheName);
	break;
      } // case
      // Display the contents of the list.
      case 'l': case 'L': {
        cout << "List in F)orward or R)everse direction? ";
        cin.get(direction_ch);
        cin.ignore(1);
        switch (direction_ch) {
          case 'f': case 'F' : {
            TheList.Display_List(FORWARD);
            break;
          } // case
          case 'r': case 'R' : {
            TheList.Display_List(REVERSE);
            break;
          } // case
          default: break;
        } // switch
	break;
      } // case
      // Save file
      case 's' : case 'S': {
        fstream outFile;
        outFile.open("file.dat", ios::out | ios::binary );
        TheList.Save_to_Disk( outFile );
        outFile.close();
        break;
      }
      // Open file
      case 'o' : case 'O': {
        fstream inFile;
        // Note error checking is included in this example
        inFile.open("file.dat", ios::in | ios::binary );
        TheList.Open_file( inFile );
        inFile.close();
        break;
      }
      // Quit running the program.
      case 'q': case 'Q': {
        TheList.Destroy_List();
	break;
      } // case
      default:
	break;
    } // switch
  } while ((command_ch != 'q') && (command_ch != 'Q'));

  cout << "Press Enter to continue.";
  cin.get();
} // main
