// Exercise 5.2.
// Demonstrates the use of pointers in structures by
// implementing a doubly linked list of records.
#include <iostream.h>

void main(void) {

  // Define the structure and its data
  // members.  You can add more members than
  // the mere name field that is shown here.
  struct list_type
  {
    char name[20];
    int age;        // Added fields for exercise 5.2.
    float salary;
    // The following point to the next entry in
    // the list and the previous entry in the
    // list, respectively.
    list_type *next;
    list_type *prev;
  };

  // head points to the front of the list.
  list_type *head = NULL;
  // tail points to the end of the list.
  list_type *tail = NULL;
  // next_entry points to the entry we are adding.
  list_type *next_entry;

  // Used to process keyboard command input.
  char command_ch;

  do {
    cout << "Select A)dd, L)ist or Q)uit? ";
    cin.get(command_ch);
    cin.ignore(1);

    switch(command_ch) {
      // Add a new entry to the list.
      case 'a': case 'A': {
	  // Allocate next entry in list.
	  if (head == NULL) { // If list is now empty...
	     next_entry = tail = head = new list_type;
	     next_entry->next = NULL;
	     next_entry->prev = NULL;
	  } // if
	  else { // List is not empty.
	     next_entry = new list_type;
	     // Set previous pointer to point at what
	     // was the last entry.
	     next_entry->prev = tail;
             // Set the previous entry's next pointer to
	     // point at the new entry.
	     tail->next = next_entry;
	     // And set tail to point the new entry.
	     tail = next_entry;
	     // And the last entry does not point
	     // anywhere so set it to NULL.
	     next_entry->next = NULL;
	  } // else
          cout << "Enter name:  ";
	  cin.getline( next_entry->name,
		       sizeof( next_entry->name ) );
          cout << "Enter age:  ";      // ADDED
          cin >> next_entry->age;      // ADDED
          cout << "Enter salary:  ";   // ADDED
          cin >> next_entry->salary;   // ADDED
          cin.ignore(1);               // ADDED
	  break;
	} // case
      // Display the contents of the list.
      case 'l': case 'L': {
	  list_type *an_entry; // Temporary pointer to entries.
	  char direction_ch;
          cout << "Display in F)orward or R)everse direction? ";
	  cin.get(direction_ch);
	  cin.ignore(1);
	  switch (direction_ch) {
            case 'f': case 'F': {
	      an_entry = head;
	      while (an_entry != NULL) {
		cout << an_entry->name << endl;
                cout << an_entry->age << " "      // ADDED
                     << an_entry->salary << endl; // ADDED
                an_entry = an_entry->next;
	      } // while
	      break;
	    } // case
            case 'r': case 'R': {
	      an_entry = tail;
	      while (an_entry != NULL) {
		cout << an_entry->name << endl;
                cout << an_entry->age << " "      // ADDED
                     << an_entry->salary << endl; // ADDED
		an_entry = an_entry->prev;
	      } // while
	    } // case
	    default: break;
	  } // switch

	  break;
	} // case
      // Quit running the program.
      case 'q': case 'Q': {
        // Delete all of the entries and free
        // up their memory allocations.  This code
        // starts at the end of the list and removes
        // each entry, one by one, until reaching
        // the beginning of the list (where
        // next_entry->prev = NULL).
        while (tail != NULL) {
          next_entry = tail->prev;
          delete tail;
          tail = next_entry;
        } // while
	break;
      } // case
      default:
	break;
    } // switch
  } while ((command_ch != 'q') && (command_ch != 'Q'));

  cout << "Press Enter to continue.";
  cin.get();

} // main
