// Exercise 5.4.
// Implements a singly linked list structure
// storing a dynamically allocated string.
#include <iostream.h>
#include <string.h>

void main(void) {

  struct list_type
  {
    char * name;
    list_type *next;
  };

  // head points to the front of the list.
  list_type *head = NULL;
  // tail points to the end of the list.
  list_type *tail = NULL;
  // next_entry points to the entry we are adding.
  list_type *next_entry;
  list_type *an_entry; // Temporary pointer to entries.

  // Used to process keyboard command input.
  char command_ch;
  char name_value[40];

  do {
    cout << "Select A)dd, L)ist or Q)uit? ";
    cin.get(command_ch);
    cin.ignore(1);

    switch(command_ch) {
      // Add a new entry to the list.
      case 'a': case 'A': {
	  // Allocate next entry in list.
	  if (head == NULL) { // If list is now empty...
	     next_entry = tail = head = new list_type;
	     next_entry->next = NULL;
	  } // if
	  else { // List is not empty.
	     next_entry = new list_type;
	     // Set previous pointer to point at what
	     // was the last entry.
	     tail->next = next_entry;
	     // And set tail to point the new entry.
	     tail = next_entry;
	     // And the last entry does not point
	     // anywhere so set it to NULL.
	     next_entry->next = NULL;
	  } // else
          cout << "Enter name:  ";
	  cin.getline( name_value, sizeof(name_value) );
          // Dynamically allocate the string for the name
          next_entry->name = new char( strlen(name_value)+1 );
          strcpy( next_entry->name, name_value );
	  break;
	} // case
      // Display the contents of the list.
      case 'l': case 'L': {
          an_entry = head;
	  while (an_entry != NULL) {
	    cout << an_entry->name << endl;
            an_entry = an_entry->next;
	  } // while
	  break;
        } // case
      // Quit running the program.
      case 'q': case 'Q': {

        // Delete all of the entries and free
        // up their memory allocations.
        next_entry = head;
        while (head != NULL) {
          delete next_entry->name;
          head = next_entry->next;
          delete next_entry;
          next_entry = head;
        } // while
	break;
      } // case
      default:
	break;
    } // switch
  } while ((command_ch != 'q') && (command_ch != 'Q'));

  cout << "Press Enter to continue.";
  cin.get();

} // main
