// Exercise 9.1.
// Demonstrates multiple inheritance by deriving
// TEuropeTimeDate from both TDate and
// TTime.

#include <iostream.h>
#include <string.h>
#include <stdio.h>

typedef char string80[80];

class TDate
{
public:
  TDate() {};
  TDate( int MonthNum, int DayNum, int YearNum );
  void SetDate( int MonthNum, int DayNum, int YearNum );
  void GetDate( int &MonthNum, int &DayNum, int &YearNum );
  void GetStringDate( string80 &DateStr);
  void GetMonth( string80 &MonthName );
protected:
  int Month, Day, Year;
};

class TTime {
public:
  void SetTime( int NewHour, int NewMinute, int NewSecond );
  void GetTime( int &Hour, int &Minute, int &Second );
  void GetStringTime ( string80 &TimeStr );
protected:
  int Hours, Minutes, Seconds;
};

// Demonstration of multiple inheritance:
// Class TEuropeTimeDate is derived from both
// TDate and TTime.  This means that
// TEuropeTimeDate incorporates the members of
// both of its parents.
class TEuropeTimeDate : public TDate, public TTime
{
public:
  TEuropeTimeDate() : TDate() {};
  TEuropeTimeDate(int DayNum, int MonthNum, int YearNum ) :
    TDate( MonthNum, DayNum, YearNum ) { };
  void GetStringDateTime( string80 &DateStr );
  void GetStringDate( string80 &DateStr);
};

//======================================================
// Implementation of TDate member functions.
TDate::TDate(int MonthNum, int DayNum,
                     int YearNum )
{
  SetDate ( MonthNum, DayNum, YearNum );
};

void TDate::SetDate( int MonthNum, int DayNum,
                         int YearNum )
{
  Month = MonthNum;
  Day = DayNum;
  Year = YearNum;
};

void TDate::GetDate( int &MonthNum, int &DayNum,
                         int &YearNum )
{
  MonthNum = Month;
  DayNum = Day;
  YearNum = Year;
};

void TDate::GetStringDate ( string80 &DateStr )
{
  sprintf( DateStr, "%d-%d-%d", Month, Day, Year % 100 );
};

void TDate::GetMonth( string80 &MonthName )
{
  static char *Months[] =
    {"January", "February", "March", "April", "May",
     "June", "July", "August", "September", "October",
     "November", "December"};
  strcpy( MonthName, Months[Month-1] );
} // GetMonth

//================================================
void TTime::SetTime( int NewHour, int NewMinute,
                     int NewSecond )
{
  Hours = NewHour;
  Minutes = NewMinute;
  Seconds = NewSecond;
};

void TTime::GetTime( int &Hour, int &Minute, int &Second )
{
  Hour = Hours;
  Minute = Minutes;
  Second = Seconds;
};

void TTime::GetStringTime ( string80 &TimeStr )
{
  sprintf( TimeStr, "%d:%d:%d", Hours, Minutes, Seconds );
};

//================================================
void TEuropeTimeDate::GetStringDateTime
                         ( string80 &DateStr )
{
  sprintf( DateStr, "%d-%d-%d  %d:%d:%d",
           Day, Month, Year, Hours, Minutes, Seconds );
};



//================================================
// Implementation of new GetStringDate() member function
void TEuropeTimeDate::GetStringDate ( string80 &DateStr )
{
  sprintf( DateStr, "%d-%d-%d", Day, Month, Year % 100 );
};


//================================================
// A main() function to demonstrate use of the two
// classes.
void main(void)
{
  TEuropeTimeDate  ADate;
  string80         DemoStr;

  // Call SetDate(), inherited from TDate.
  ADate.SetDate( 1, 31, 1993 );
  // Call SetTime(), inherited from TTime.
  ADate.SetTime( 14,30, 45 );
  ADate.GetStringDateTime( DemoStr );
  cout << "The date and time is:  " << DemoStr << endl;

  // Call the now added (for this exercise)
  // GetStringDate to convert to European format.
  ADate.GetStringDate( DemoStr );
  cout << "The date is:  " << DemoStr << endl;

/*
  // Commented out since this no longer applies...
  // Demonstrate calling the inherited GetStringDate()
  // member (from TDate ancestor).
  ADate.GetStringDate( DemoStr );
  cout << "The date is: " << DemoStr << endl;
*/

  // Demonstrate calling the inherited GetStringTime()
  // member (from TTime).
  ADate.GetStringTime( DemoStr );
  cout << "The time is: " << DemoStr << endl;

  cout << "Press Enter to continue.";
  cin.get();
} // main

