// LIST-MOD.H
// This is the header file containing the definitions
// definitions of the symbols that are made available
// to users of this module.
#include <fstream.h>

const int FORWARD = 0;
const int REVERSE = 1;
const int MAXNAMESIZE = 20;

// Define the list_type object as
// a structure containing data fields,
// next and previous link pointers,
// and the Add_to_Tail() and Display_List()
// functions to operate on the list.
struct list_element
{
  char name[MAXNAMESIZE];
  // The following point to the next entry in
  // the list and the previous entry in the
  // list, respectively.
  list_element *next;
  list_element *prev;
};

struct list_type
{
  list_element *head;  // Points to front of the list
  list_element *tail;  // Points to the end of the list
  void Initialize_List(void);  // Initializes head & tail
  void Add_to_Tail(char name_to_add[]);
  void Display_List(int Direction);
  void Destroy_List(void);
  void Save_to_Disk(fstream &outfile);
  void Open_file(fstream &infile);
};

